// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "Splits.h"

#include "ChildFrm.h"

//SAMPLE: need to reference other stuff
#include "YView.h"
#include "XView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_COMMAND(ID_VIEW_XVIEW, OnViewXview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_XVIEW, OnUpdateViewXview)
	ON_COMMAND(ID_VIEW_YVIEW, OnViewYview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_YVIEW, OnUpdateViewYview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	//SAMPLE: Create a static splitter instead of a regular
	// splitter. Ask for one row and 2 columns.

	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	//SAMPLE: create a view like we were asked
	// initial size of 100, 100 is arbitrary

	if (!m_wndSplitter.CreateView(0, 0,
		pContext->m_pNewViewClass, CSize(100, 100), pContext))
	{
		return FALSE;
	}

	//SAMPLE: initialy create an X-view, too

	pContext->m_pNewViewClass = RUNTIME_CLASS(CXView);
	if (!m_wndSplitter.CreateView(0, 1,
		pContext->m_pNewViewClass, CSize(100, 100), pContext))
	{
		return FALSE;
	}

	return TRUE;
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIChildWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

void CChildFrame::OnViewXview() 
{
	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	CYView* pOldView = DYNAMIC_DOWNCAST(CYView, pWnd);
	ASSERT(pOldView != NULL);

	CDocument* pDoc = pOldView->GetDocument();

	//SAMPLE: kill the existing view

	m_wndSplitter.DeleteView(0, 1);

	//SAMPLE: create an XView in its place

	CCreateContext ctxt;
	ctxt.m_pCurrentDoc = pDoc;

	VERIFY(m_wndSplitter.CreateView(0, 1,
		RUNTIME_CLASS(CXView), CSize(100, 100), &ctxt));
	m_wndSplitter.RecalcLayout();
}

void CChildFrame::OnUpdateViewXview(CCmdUI* pCmdUI) 
{
	//SAMPLE: use runtime type info to decide if we're
	// showing X View right now

	pCmdUI->Enable(TRUE);

	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	if (pWnd->IsKindOf(RUNTIME_CLASS(CXView)))
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CChildFrame::OnViewYview() 
{
	//SAMPLE: get the existing view
	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	CXView* pOldView = DYNAMIC_DOWNCAST(CXView, pWnd);
	ASSERT(pOldView != NULL);

	CDocument* pDoc = pOldView->GetDocument();

	//SAMPLE: kill the existing view

	m_wndSplitter.DeleteView(0, 1);

	//SAMPLE: create an XView in its place

	CCreateContext ctxt;
	ctxt.m_pCurrentDoc = pDoc;

	VERIFY(m_wndSplitter.CreateView(0, 1,
		RUNTIME_CLASS(CYView), CSize(100, 100), &ctxt));
	m_wndSplitter.RecalcLayout();
}

void CChildFrame::OnUpdateViewYview(CCmdUI* pCmdUI) 
{
	//SAMPLE: use runtime type info to decide if we're
	// showing X View right now

	pCmdUI->Enable(TRUE);

	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	if (pWnd->IsKindOf(RUNTIME_CLASS(CYView)))
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
